///////////////////////////////////////////////////////////////////////////////
//
//  CodeJock.PushButton
//
// Notes about PushButton:
//
// 1. Font doesn't work.  Locks up application
//
///////////////////////////////////////////////////////////////////////////////


#include "dcdialog.ch"
#INCLUDE "XCodeJock.CH"
#include "Suite.ch"
#INCLUDE "cjbitmap.CH"
#INCLUDE "cjicon.CH"
#include "appevent.ch"

#pragma Library("ASCOM10.LIB")

#define ON .t.
#define OFF .f.

#DEFINE Button_Click  xbeP_User+100

FUNCTION Main()

LOCAL GetList[0], GetOptions, oGroupBox1, oGroupStyle, nVisualStyle, bAction, ;
      oDlg, oButton1, oButton2, oButton3, cCaption, oGlobal, nStyle, ;
      oGroupButtonStyle, oDropMenu, oSkin, oAppDeskTop := AppDeskTop(), cSkin

oGlobal := CreateObject('Codejock.SuiteControlsGlobalSettings' + CJ_Version())
CJLoadIcon '..\..\..\..\icon\book.ico' ID 2 STATE xtpImageNormal PARENT oGlobal:icons

nVisualStyle := xtpAppearanceStandard
nStyle := xtpButtonSplitDropDown

@ 0,0 CJGROUPBOX oGroupBox1 ;
      SIZE 38, 17 ;
      FONT '12.Arial Bold' ;
      COLOR GRA_CLR_BLACK, GRA_CLR_WHITE ;
      CAPTION 'PushButton Styles' ;
      RESIZE DCGUI_RESIZE_RESIZEONLY ;
      RIGHTTOLEFT

@ 2,2 CJPushButton oButton1 ;
       Size 25,2 ;
       Caption 'Push Me. I really need to be pushed. Please!!' ;
       ToolTip 'This is a CodeJock PushButton with no markup' ;
       Font '12.Arial Bold' ;
       Bitmap '..\..\..\..\bitmaps\bug.bmp' ;
       TextImageRelation xtpTextBeforeImage ;
       Transparent ;
       EnableMarkup ;
       ;// Checked ;
       Appearance nVisualStyle ;
       Style nStyle ;
       Color GRA_CLR_RED, GRA_CLR_WHITE ;
       Parent oGroupBox1 ;
       ReSize DCGUI_RESIZE_RESIZEONLY ;
       ACTION {|o|PostAppEvent(Button_Click,{||MsgBox('Testing')},,o)} ;
       ACCELKEY xbeK_F12 ;
       DROPDOWN {|a,b,c|oDropMenu:PopUp(oButton1,{0,0}, 2, ;
              XBPMENU_PU_DEFAULT + XBPMENU_PU_MOUSE_RBDOWN  )}

DCUSEREVENT Button_Click ACTION {|a|Eval(a)}

TEXT INTO cCaption WRAP
<Border Padding='4' BorderThickness='1' BorderBrush='#767676' Background='#e4ecf7'>
<StackPanel TextBlock.FontFamily='Tahoma'>
   <TextBlock Padding='1, 3, 1, 3' FontWeight='Bold'>Change Case</TextBlock>
   <TextBlock Padding='9, 6, 30, 7' TextWrapping='Wrap'>Change all the selected text to UPPERCASE, lowercase, or other common capitalizations.</TextBlock>
   <Border Height='1' Background='#9ebbdd' />
   <Border Height='1' Background='White' />
   <StackPanel Margin='1, 7, 0, 3' Orientation='Horizontal'>
        <Image Source='2'/><TextBlock Margin='7, 0, 0, 0' VerticalAlignment='Center' FontWeight='Bold'>Press F1 for more help.</TextBlock>
   </StackPanel>
   </StackPanel>
</Border>
ENDTEXT

@ 5,2 CJPUSHBUTTON oButton2 ;
       SIZE 34,8 ;
       PARENT oGroupBox1 ;
       CAPTION cCaption ;
       APPEARANCE nVisualStyle ;
       STYLE nStyle ;
       ICON '..\..\..\..\icon\express.ico' ;
       TOOLTIP 'This is a CodeJock CheckBox with Markup text: ' + Chr(13)+Chr(13) + cCaption ;
       ENABLEMARKUP ;
       WHEN {||nStyle # xtpButtonDropDown} ;
       COLOR GRA_CLR_BLACK, GRA_CLR_WHITE ;
       RESIZE DCGUI_RESIZE_NONE ;
       ACTION {|o|MsgBox('I am Very Cool')} ;
       DROPDOWN {|a,b,c|oDropMenu:PopUp(oButton2,{0,0}, 2, ;
              XBPMENU_PU_DEFAULT + XBPMENU_PU_MOUSE_RBDOWN  )}

@ 14,2 DCPUSHBUTTONXP OBJECT oButton3 CAPTION 'Xbase++ Button' ;
      SIZE 30,2 ;
      FONT '10.Arial Bold' ;
      RADIUS 10 ;
      ACTION {||DC_Msgbox('I am Xbase++')} ACCELKEY xbeK_F11 ;
      PARENT oGroupBox1

@ 0, 42 DCGROUP oGroupStyle CAPTION 'Visual Style' SIZE 20,9 ;
        RESIZE DCGUI_RESIZE_REPOSONLY

bAction := {||oGroupBox1:appearance := nVisualStyle, ;
              oButton1:appearance := nVisualStyle, ;
              oButton2:appearance := nVisualStyle, ;
              oGroupBox1:useVisualStyle := .f., ;
              oButton1:useVisualStyle := .f., ;
              oButton2:useVisualStyle := .f.}

@ 1,2 DCRADIO nVisualStyle VALUE xtpAppearanceStandard PROMPT 'Standard' PARENT oGroupStyle ACTION bAction
@ 2,2 DCRADIO nVisualStyle VALUE xtpAppearanceUltraFlat PROMPT 'Ultra Flat' PARENT oGroupStyle ACTION bAction
@ 3,2 DCRADIO nVisualStyle VALUE xtpAppearanceOfficeXP PROMPT 'Office XP' PARENT oGroupStyle ACTION bAction
@ 4,2 DCRADIO nVisualStyle VALUE xtpAppearanceOffice2000 PROMPT 'Office 2000' PARENT oGroupStyle ACTION bAction
@ 5,2 DCRADIO nVisualStyle VALUE xtpAppearanceOffice2003 PROMPT 'Office 2003' PARENT oGroupStyle ACTION bAction
@ 6,2 DCRADIO nVisualStyle VALUE -1 PROMPT 'Use Visual Style' PARENT oGroupStyle ;
      ACTION {||oGroupBox1:useVisualStyle := .t., ;
                oButton1:useVisualStyle := .t., ;
                oButton2:useVisualStyle := .t.}

@ 10, 42 DCGROUP oGroupButtonStyle CAPTION 'Button Style' SIZE 20,6 ;
       RESIZE DCGUI_RESIZE_REPOSONLY

bAction := {||oButton1:style := nStyle, ;
              oButton2:style := nStyle}

@ 1,2 DCRADIO nStyle VALUE xtpButtonNormal PROMPT 'Normal' PARENT oGroupButtonStyle ACTION bAction
@ 2,2 DCRADIO nStyle VALUE xtpButtonDropDown PROMPT 'Drop Down' PARENT oGroupButtonStyle ACTION bAction
@ 3,2 DCRADIO nStyle VALUE xtpButtonDropDownRight PROMPT 'Drop Down Right' PARENT oGroupButtonStyle ACTION bAction
@ 4,2 DCRADIO nStyle VALUE xtpButtonSplitDropDown PROMPT 'Split Drop Down' PARENT oGroupButtonStyle ACTION bAction

cSkin := '..\..\..\styles\Vista.cjStyles'
@ 18,0 DCPUSHBUTTON CAPTION 'Apply Vista Skin' ;
        ACCELKEY xbeK_F10 ;
        SIZE 15,1.2 ;
        ACTION {||oSkin:LoadSkin(cSkin,''), ;
                  oSkin:applyWindow(oDlg:getHwnd())}

@ 0,0 DCACTIVEXCONTROL oSkin SIZE 1,1 PIXEL ;
      CLSID 'Codejock.SkinFramework' + CJ_Version() ;
      PARENT oAppDeskTop

DCSUBMENU oDropMenu PROMPT 'Menu'
  DCMENUITEM 'Menu Item 1' PARENT oDropMenu
  DCMENUITEM 'Menu Item 2' PARENT oDropMenu

DCGETOPTIONS ;
   RESIZE ;
   TOOLTIPCOLOR GRA_CLR_BLACK, GRA_CLR_YELLOW ;
   TOOLTIPFONT '10.Lucida Console' ;
   HIDE


DCREAD GUI FIT TITLE 'CodeJock PushButton Sample' OPTIONS GetOptions ;
   PARENT @oDlg ;
   EVAL {|o|o:SetPos({o:CurrentPos()[1]-100,o:currentPos()[2]}), ;
            o:show(), ;
            CJ_SetAppFocus(oButton1:hwnd), ;
            DC_CompleteEvents(), ;
            Sleep(150), ;
            CJ_SetAppFocus(oButton2:hwnd), ;
            nil }

oGlobal:destroy()

RETURN nil

* ------------

PROC appsys ; RETURN
